package sun.font;

import sun.java2d.Disposer;
import sun.java2d.DisposerRecord;

class FontStrikeDisposer implements DisposerRecord, Disposer.PollDisposable
{
    Font2D font2D;
    FontStrikeDesc desc;
    long[] longGlyphImages;
    int[] intGlyphImages;
    int[][] segIntGlyphImages;
    long[][] segLongGlyphImages;
    long pScalerContext;
    boolean disposed;
    boolean comp;
    
    public FontStrikeDisposer(Font2D font2D, FontStrikeDesc desc, long pScalerContext, int[] intGlyphImages) {
        this.pScalerContext = 0L;
        this.disposed = false;
        this.comp = false;
        this.font2D = font2D;
        this.desc = desc;
        this.pScalerContext = pScalerContext;
        this.intGlyphImages = intGlyphImages;
    }
    
    public FontStrikeDisposer(Font2D font2D, FontStrikeDesc desc, long pScalerContext, long[] longGlyphImages) {
        this.pScalerContext = 0L;
        this.disposed = false;
        this.comp = false;
        this.font2D = font2D;
        this.desc = desc;
        this.pScalerContext = pScalerContext;
        this.longGlyphImages = longGlyphImages;
    }
    
    public FontStrikeDisposer(Font2D font2D, FontStrikeDesc desc, long pScalerContext) {
        this.pScalerContext = 0L;
        this.disposed = false;
        this.comp = false;
        this.font2D = font2D;
        this.desc = desc;
        this.pScalerContext = pScalerContext;
    }
    
    public FontStrikeDisposer(Font2D font2D, FontStrikeDesc desc) {
        this.pScalerContext = 0L;
        this.disposed = false;
        this.comp = false;
        this.font2D = font2D;
        this.desc = desc;
        this.comp = true;
    }
    
    @Override
    public synchronized void dispose() {
        if (!this.disposed) {
            this.font2D.removeFromCache(this.desc);
            StrikeCache.disposeStrike(this);
            this.disposed = true;
        }
    }
}
